﻿using System;
using System.Collections;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;


public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        DataTable tblEmp = this.GetEmployees(10);
        DataTable tblEmpDetails = this.GetEmployeeDetails(10);

        DataSet dsEmp = new DataSet();
        dsEmp.Tables.Add(tblEmp);
        dsEmp.Tables.Add(tblEmpDetails);

        DataRelation rel = new DataRelation("empRelation", dsEmp.Tables["Employees"].Columns["EmployeeID"], dsEmp.Tables["EmployeeDetails"].Columns["EmployeeID"]);
        dsEmp.Relations.Add(rel);

        this.WebHierarchicalDataGrid1.DataSource = dsEmp;

        Session["Emp"] = dsEmp;

        Session.Timeout = 1;
    }


    private DataTable GetEmployees(int count)
    {
        DataTable dtData = new DataTable("Employees");

        dtData.Columns.Add("EmployeeID", typeof(int));
        dtData.Columns.Add("Name", typeof(string));
        dtData.Columns.Add("OnSite", typeof(bool));
        dtData.Columns.Add("DateOfHire", typeof(DateTime));
        dtData.Columns.Add("Department", typeof(int));
        dtData.Columns.Add("Site", typeof(string));

        for (int i = 0; i < count; i++)
        {
            dtData.Rows.Add(new object[] { i, string.Format("Name {0} ", i), (i % 2 == 0), DateTime.Today.Date.AddDays(-1 * i), i % 8, "http://www.google.com" });
        }
        dtData.Rows.Add(new object[] { 100, string.Format("The AllowNull property allows having null values in the column  {0} ", 100), (100 % 2 == 0), DateTime.Today.Date.AddDays(-1 * 100), 100 % 8, "http://www.google.com" });

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

        return dtData;
    }

    private DataTable GetEmployeeDetails(int count)
    {
        DataTable dtData = new DataTable("EmployeeDetails");

        dtData.Columns.Add("EmployeeID", typeof(int));
        dtData.Columns.Add("FirstName", typeof(string));
        dtData.Columns.Add("LastName", typeof(string));
        dtData.Columns.Add("Address", typeof(string));

        for (int i = 0; i < count; i++)
        {
            dtData.Rows.Add(new object[] { i, string.Format("First Name {0}", i), string.Format("Last Name {0}", i), string.Format("Address {0}", i) });
        }

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

        return dtData;
    }    
 
    protected void WHDG_DataBound(object sender, EventArgs e)
    {        
        ArrayList list = new ArrayList();

         WebHierarchicalDataGrid1.GridView.Columns.FromKey("EmployeeID");
        for (int i = 0; i <= WebHierarchicalDataGrid1.GridView.Rows.Count; i++)
        {
            if((i == 0) | (i == 3))
            this.WebHierarchicalDataGrid1.GridView.Rows[i].Expanded = true;            
        }
    }
    protected void WHDG_InitializeRow(object sender, RowEventArgs e)
    {
        //ContainerGridRecord row = (ContainerGridRecord)e.Row;
        //ContainerGridRecordCollection childRows = row.RowIslands[0].Rows;

    }
}
